'use strict';
var vue_class_component_1 = require("vue-class-component");
require("reflect-metadata");
var vue_property_decorator_1 = require("./vue-property-decorator");
exports.Watch = vue_property_decorator_1.Watch;
exports.Component = vue_property_decorator_1.Component;
/**
 * decorator of a prop
 * @param  options the option for the prop
 * @return PropertyDecorator
 */
function Prop(options) {
    if (options === void 0) { options = {}; }
    return function (target, key) {
        if (!(options instanceof Array) && typeof options.type === 'undefined') {
            options.type = Reflect.getMetadata('design:type', target, key);
        }
        vue_class_component_1.createDecorator(function (componentOptions, k) {
            (componentOptions.props || (componentOptions.props = {}))[k] = options;
        })(target, key);
    };
}
exports.Prop = Prop;
exports.prop = Prop;
