import Vue = require('vue');
import { PropOptions } from 'vue';
import VueClassComponent from 'vue-class-component';
export declare type Constructor = {
    new (...args: any[]): any;
};
/**
 * decorator of a prop
 * @param  options the option for the prop
 * @return PropertyDecorator
 */
export declare function Prop(options?: (PropOptions | Constructor | Constructor[])): PropertyDecorator;
/**
 * decorator of a watch function
 * @param  path the path or the expression to observe
 * @param  WatchOption
 * @return MethodDecorator
 */
export declare function Watch(path: string, options?: Vue.WatchOptions): MethodDecorator;
export declare const prop: typeof Prop;
export declare const watch: typeof Watch;
export declare const Component: typeof VueClassComponent;
