/* vue-property-decorator verson 3.3.0 MIT LICENSE copyright 2016 kaorun343 */
'use strict';
var vue_class_component_1 = require("vue-class-component");
/**
 * decorator of a prop
 * @param  options the option for the prop
 * @return PropertyDecorator
 */
function Prop(options) {
    if (options === void 0) { options = { type: null }; }
    return vue_class_component_1.createDecorator(function (componentOptions, key) {
        (componentOptions.props || (componentOptions.props = {}))[key] = options;
    });
}
exports.Prop = Prop;
/**
 * decorator of a watch function
 * @param  path the path or the expression to observe
 * @param  WatchOption
 * @return MethodDecorator
 */
function Watch(path, options) {
    if (options === void 0) { options = {}; }
    var _a = options.deep, deep = _a === void 0 ? false : _a, _b = options.immediate, immediate = _b === void 0 ? false : _b;
    return vue_class_component_1.createDecorator(function (componentOptions, handler) {
        if (typeof componentOptions.watch !== 'object') {
            componentOptions.watch = Object.create(null);
        }
        componentOptions.watch[path] = { handler: handler, deep: deep, immediate: immediate };
    });
}
exports.Watch = Watch;
exports.prop = Prop;
exports.watch = Watch;
exports.Component = vue_class_component_1.default;
